* Logical ops
*
* pjwitte 2o23+
* All code is my own work except as and where stated
*
* V0,01, pjw, 1996 Apr 4
* V0.02, pjw, 2023 Aug 17, re-write. Split out BIT_
*
* Compatible with QDOS, Minerva and SMSQ/E
*


        section code

        xdef LOG_NOT

        xref fixpar,lin2fltd6,resrir

        include dev8_keys_sbasic
        include dev8_keys_qlv
        include dev8_keys_err


*
LOG_NOT
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
*
* result = LOG_NOT(op [, size]) => ~~ op
*

        move.w sb.gtlin,a2
        jsr (a2)
        bne.s exit

        subq.w #1,d3
        blt.s err

        beq.s onepar

        cmpi.w #1,d3
        bne.s err

        movem.l (a6,a1.l),d6/d7
        moveq #2,d2             tidy 8-6b off stack
        bsr fixpar

        bra.s do_not

onepar
        moveq #8,d7             default size 32 bit
        move.l (a6,a1.l),d6
        moveq #2,d1             on one par, two more bytes needed
        bsr resrir

do_not
        lea.l not,a4
        lea.l (a4,d7.l),a4
        jmp (a4)

not
        not.b d6
        bra.s ok

        not.w d6
        bra.s ok

        not.l d6

ok
        bra lin2fltd6

err
        moveq #err.ipar,d0
exit
        rts

*
        end
