* Logical ops
*
* pjwitte 2o23+
* All code is my own work except as and where stated
*
* V0,01, pjw, 1996 Apr 4
* V0.02, pjw, 2023 Aug 17, re-write. Split out BIT_
*
* Compatible with QDOS, Minerva and SMSQ/E
*


        section code

        xdef LOG_AND,LOG_XOR,LOG_OR

        xref getops,lin2fltd6


*
LOG_AND
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
*
* result = LOG_AND(op1, op2 [,size%]) => op1 && op2, default long
*
        bsr getops
        and.l d0,d6

*
done
        bra lin2fltd6


*
LOG_XOR
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
*
* result = LOG_XOR(op1, op2 [, size]) => op1 ^^ op2
*
        bsr getops

        eor.l d0,d6
        bra.s done


*
LOG_OR
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
*
* result = LOG_OR(op1, op2 [, size]) => op1 || op2
*
        bsr getops

        or.l d0,d6
        bra.s done

*
        end
